/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.All
{
    /// <summary>
    /// SampleParentFavoriteBookTitle
    /// </summary>
    [DataContract(Name = "sample_parentFavoriteBookTitle")]
    public partial class SampleParentFavoriteBookTitle : IEquatable<SampleParentFavoriteBookTitle>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleParentFavoriteBookTitle" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SampleParentFavoriteBookTitle() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleParentFavoriteBookTitle" /> class.
        /// </summary>
        /// <param name="favoriteBookTitle">The title of the parent&#39;s favorite book. (required).</param>
        public SampleParentFavoriteBookTitle(string favoriteBookTitle = default(string))
        {
            // to ensure "favoriteBookTitle" is required (not null)
            if (favoriteBookTitle == null) {
                throw new ArgumentNullException("favoriteBookTitle is a required property for SampleParentFavoriteBookTitle and cannot be null");
            }
            this.FavoriteBookTitle = favoriteBookTitle;
        }

        /// <summary>
        /// The title of the parent&#39;s favorite book.
        /// </summary>
        /// <value>The title of the parent&#39;s favorite book.</value>
        [DataMember(Name = "favoriteBookTitle", IsRequired = true, EmitDefaultValue = false)]
        public string FavoriteBookTitle { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SampleParentFavoriteBookTitle {\n");
            sb.Append("  FavoriteBookTitle: ").Append(FavoriteBookTitle).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SampleParentFavoriteBookTitle);
        }

        /// <summary>
        /// Returns true if SampleParentFavoriteBookTitle instances are equal
        /// </summary>
        /// <param name="input">Instance of SampleParentFavoriteBookTitle to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SampleParentFavoriteBookTitle input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.FavoriteBookTitle == input.FavoriteBookTitle ||
                    (this.FavoriteBookTitle != null &&
                    this.FavoriteBookTitle.Equals(input.FavoriteBookTitle))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FavoriteBookTitle != null)
                {
                    hashCode = (hashCode * 59) + this.FavoriteBookTitle.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // FavoriteBookTitle (string) maxLength
            if (this.FavoriteBookTitle != null && this.FavoriteBookTitle.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FavoriteBookTitle, length must be less than 100.", new [] { "FavoriteBookTitle" });
            }

            yield break;
        }
    }

}
