/*
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * The version of the OpenAPI document: 3
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = EdFi.OdsApi.Sdk.Client.OpenAPIDateConverter;

namespace EdFi.OdsApi.Sdk.Models.All
{
    /// <summary>
    /// SampleStudentArtProgramAssociationStyle
    /// </summary>
    [DataContract(Name = "sample_studentArtProgramAssociationStyle")]
    public partial class SampleStudentArtProgramAssociationStyle : IEquatable<SampleStudentArtProgramAssociationStyle>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleStudentArtProgramAssociationStyle" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SampleStudentArtProgramAssociationStyle() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SampleStudentArtProgramAssociationStyle" /> class.
        /// </summary>
        /// <param name="style">The art style(s) exhibited by the student in the program. (required).</param>
        public SampleStudentArtProgramAssociationStyle(string style = default(string))
        {
            // to ensure "style" is required (not null)
            if (style == null) {
                throw new ArgumentNullException("style is a required property for SampleStudentArtProgramAssociationStyle and cannot be null");
            }
            this.Style = style;
        }

        /// <summary>
        /// The art style(s) exhibited by the student in the program.
        /// </summary>
        /// <value>The art style(s) exhibited by the student in the program.</value>
        [DataMember(Name = "style", IsRequired = true, EmitDefaultValue = false)]
        public string Style { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SampleStudentArtProgramAssociationStyle {\n");
            sb.Append("  Style: ").Append(Style).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SampleStudentArtProgramAssociationStyle);
        }

        /// <summary>
        /// Returns true if SampleStudentArtProgramAssociationStyle instances are equal
        /// </summary>
        /// <param name="input">Instance of SampleStudentArtProgramAssociationStyle to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SampleStudentArtProgramAssociationStyle input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Style == input.Style ||
                    (this.Style != null &&
                    this.Style.Equals(input.Style))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Style != null)
                {
                    hashCode = (hashCode * 59) + this.Style.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        public IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> Validate(ValidationContext validationContext)
        {
            // Style (string) maxLength
            if (this.Style != null && this.Style.Length > 50)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Style, length must be less than 50.", new [] { "Style" });
            }

            yield break;
        }
    }

}
